﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr177_1
{
    // Объявление делегата: 
    delegate double Powers(double x);
    
    // Главный класс:
    class Program
    {
        // Статический метод результатом возвращает ссылку 
        // на экземпляр делегата: 
        static Powers maker(int n) {
            // Локальная переменная типа делегата:
            Powers meth;
            // Значением переменной типа делегата присваивается 
            // анонимный метод: 
            meth = delegate(double x) { 
                double s = 1;
                // Вычисление произведения: 
                for(int i = 1;i <= n; i++) { 
                    s *= x;
                }
                return s; // Результат анонимного метода
            };
            return meth; // Результат статического метода
        }

        // Главный метод: 
        static void Main()
        {
            // Первый экземпляр делегата:
            Powers sqr = maker(2);
            // Второй экземпляр делегата:
            Powers cube = maker(3);
            // Вызов экземпляров делегата: 
            for(int i = 1; i <= 5; i++) {
                Console.WriteLine("{0,2}:{1,5}{2,5}{3,5}", i, sqr(i), cube(i), maker(4)(i));
            }
            // Задержка:
            Console.ReadLine();
        }
    }
}
